<?php

namespace %NAMESPACE%\Middleware;

use Psr\Http\Server\MiddlewareInterface;
use Psr\Http\Message\ServerRequestInterface;
use Psr\Http\Server\RequestHandlerInterface;
use Psr\Http\Message\ResponseInterface;

use Storage\Session;

class Authentication implements MiddlewareInterface {

    public Session $session;

    public string $sessionUserVariable = 'user';

    public ResponseInterface $loginRedirect;

    public function __construct(ResponseInterface $loginRedirect, Session $session)
    {
        $this->loginRedirect = $loginRedirect;
        $this->session = $session;
    }

    #[param  ServerRequestInterface  $request]
    #[param  RequestHandlerInterface $handler]
    #[return ResponseInterface]
    public function process(ServerRequestInterface $request, RequestHandlerInterface $handler) : ResponseInterface
    {
        $user = $this->session->get( $this->sessionUserVariable() );

        if ( ! $user ) {
            return $this->loginRedirect;
        }

        return $handler->handle($request);
    }

    #[param string|null sessionUserVariable]
    #[return mixed]
    public function sessionUserVariable(?string $set = null) : string
    {
        return $set !== null ? $this->sessionUserVariable = $set : $this->sessionUserVariable;
    }
}
